var Emoticons = new Array();
Emoticons[':@'] = "chrome://msnmsgr/skin/emoticons/angry.png";
Emoticons[':D'] = "chrome://msnmsgr/skin/emoticons/bigsmile.png";
Emoticons[':S'] = "chrome://msnmsgr/skin/emoticons/confused.png";
Emoticons[':|'] = "chrome://msnmsgr/skin/emoticons/disappointed.png";
Emoticons[':)'] = "chrome://msnmsgr/skin/emoticons/happy.png";
Emoticons[':('] = "chrome://msnmsgr/skin/emoticons/sad.png";
Emoticons[':P'] = "chrome://msnmsgr/skin/emoticons/stickouttongue.png";
Emoticons[':O'] = "chrome://msnmsgr/skin/emoticons/suprised.png";
Emoticons[';)'] = "chrome://msnmsgr/skin/emoticons/wink.png";

var prefObserver = {
  observe : function() { window.fontChanged(); },
  QueryInterface : function (aIID) {
    if (aIID.equals(Components.interfaces.nsIObserver) || 
      aIID.equals(Components.interfaces.nsISupports) ||
      aIID.equals(Components.interfaces.nsISupportsWeakReference))
      return this;
      throw Components.results.NS_NOINTERFACE;
  }
}

function onSessionLoad() {
  var contactID = window.arguments[0].contactID;
  this.client = window.arguments[0].client;
  if (typeof(window.arguments[1]) != "undefined") {
    var host = window.arguments[1].host;
    var port = window.arguments[1].port;
    var cki = window.arguments[1].cki;
    var sessionID = window.arguments[1].sessionID;
    this.session = new MSNSession(this.client, contactID);
    this.session.answer(host, port, cki, sessionID);
  }
  else {
    this.session = new MSNSession(this.client, contactID);
    this.client.grabSession(this.session);
  }
  document.title = contactID;
  var noMessagesReceived = window.session.bundle.GetStringFromName("noMessagesReceived");
  document.getElementById("status-bar-main").firstChild.setAttribute("label", noMessagesReceived);
  this.lastMsgRcvTime = null;
  this.MMS_FN = "Arial";
  this.MMS_CO = "#000000";
  this.MMS_EF_B = false;
  this.MMS_EF_I = false;
  this.MMS_EF_U = false;
  this.MMS_EF_S = false;
  addPrefObserver();
  contactsChanged();
  window.fontChanged();
  changeFontSize("small");
  document.getElementById("message").focus();
}

function onSessionUnload() {
  if (typeof(window.fileStream) != "undefined") {
    window.fileStream.close();
  }
  window.session.exit();
}

window.fontChanged = function() {
  try {
    this.MMS_FN = prefBranch.getCharPref("font.name");
    this.MMS_CO = prefBranch.getCharPref("font.color");
    this.MMS_EF_B = prefBranch.getBoolPref("font.bold");
    this.MMS_EF_I = prefBranch.getBoolPref("font.italic");
    this.MMS_EF_U = prefBranch.getBoolPref("font.underline");
    this.MMS_EF_S = prefBranch.getBoolPref("font.strike");
  }
  catch (ex) {
    saveDefaultPrefs();
  }
  var mms = "FN=" + escape(this.MMS_FN) + "; EF=";
  if (this.MMS_EF_B)
    mms += "B";
  if (this.MMS_EF_U)
    mms += "U";
  if (this.MMS_EF_I)
    mms += "I";
  if (this.MMS_EF_S)
    mms += "S";
  mms += "; CO=" + swapRedBlue(this.MMS_CO.substr(1, 6)) + "; CS=0; PF=00";
  this.MMS = mms;
  document.getElementById("message").setAttribute("style", convertXMMStoStyle(this.MMS));
}

window.answerIncomingSession = function(contactID, host, port, cki, sessionID) {
  this.session.exit();
  this.session = new MSNSession(this.client, contactID);
  this.session.answer(host, port, cki, sessionID);
}

function createNewSession(contactID) {
  this.session.exit();
  this.session = new MSNSession(this.client, contactID);
  this.client.grabSession(this.session);
}

function contactsChanged() {
  var talkingToString = window.session.generateTalkingToString();
  window.document.getElementById("chat-participants").firstChild.nodeValue = talkingToString;
}

function showIM(from, fromID, msgText, mms, myMsg) {
  this.lastMsgRcvTime = getTimeStamp();
  if (typeof(this.fileStream) != "undefined") {
    logIM(fromID, msgText);
  }
  var textcontent = this.createMessageContentNode(msgText, mms);
  this.createMessageNode(from, textcontent, myMsg);
}

function showNotificationMessage(text) {
  var doc = window.document;
  var msg = doc.createElementNS(XHTML, "div");
  msg.setAttribute("class", "NotificationMessage");
  var textNode = doc.createTextNode(text);
  msg.appendChild(textNode);
  this.appendAndScroll(msg);
}

function setStatus(statusMsg) {
  var shownStatusMsg;
  if (statusMsg != "") {
    shownStatusMsg = statusMsg;
  }
  else {
    if (this.lastMsgRcvTime != null) {
      shownStatusMsg = this.session.bundle.GetStringFromName("lastMessageReceived").replace("%T", this.lastMsgRcvTime);
    }
    else {
      shownStatusMsg = this.session.bundle.GetStringFromName("noMessagesReceived");
    }
  }
  document.getElementById("status-bar-main").firstChild.setAttribute("label", shownStatusMsg);
}

function sendIM(e) {
  if ((e.type == "command") || (e.type == "keypress" && e.keyCode == 13 && e.shiftKey == false)) {
    var msgText = document.getElementById("message").value;
    if (msgText != '') {
      window.document.getElementById("message").value = '';
      var msgNode = this.createMessageContentNode(msgText, window.MMS);
      this.createMessageNode(window.client.nickname, msgNode, true);
      e.preventDefault();
      if (typeof(window.fileStream) != "undefined") {
        logIM(window.client.passport, msgText);
      }
      window.session.sendIM(uniConvertFrom(msgText), window.MMS);
    }
  }
  else {
    this.session.handleTyping();
  }
}

function catchLink(e) {
  var href = this.href;
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
  var recentWindow = wm.getMostRecentWindow("navigator:browser");
  if (recentWindow != null) {
    var theBrowser = recentWindow.getBrowser();
    var addedTab = theBrowser.addTab(href);
    theBrowser.selectedTab = addedTab;
  }
  else {
    window.open(href);
  }
  e.preventDefault();
}

function logConversation() {
  var logging = document.getElementById("window-log").getAttribute("checked");
  if (logging == "true") {
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
                 .getService(Components.interfaces.nsIProperties)
                 .get("ProfD", Components.interfaces.nsIFile);
    file.append("logs");
    if (!file.exists() || !file.isDirectory() ) {
      file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
    }
    file.append(window.session.getFirstContactID() + ".log");
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                     .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(file, 0x02 | 0x08 | 0x10, 0664, 0);
    window.fileStream = foStream;
    showNotificationMessage(window.session.bundle.GetStringFromName("logOn"));
  }
  else {
    window.fileStream.close();
    delete window.fileStream;
    showNotificationMessage(window.session.bundle.GetStringFromName("logOff"));
  }
}

function changeFontSize(class) {
  document.getElementById("chat-panel").contentDocument.body.setAttribute("class", class);
  document.getElementById("message").setAttribute("class", class);
}

function onContextMenu() {
  var element = document.popupNode;
  var isLink = element instanceof HTMLAnchorElement;
  document.getElementById("cmd-copy").hidden = isLink;
  document.getElementById("cmd-copyLink").hidden = !isLink;
}

function addPrefObserver() {
  var pbi = prefService.QueryInterface(nsIPrefBranchInternal);
  pbi.addObserver("extensions.msnmsgr.font.name", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.color", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.bold", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.italic", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.underline", prefObserver, true);
  pbi.addObserver("extensions.msnmsgr.font.strike", prefObserver, true);
}

function saveDefaultPrefs() {
  prefBranch.setCharPref("font.name", this.MMS_FN);
  prefBranch.setBoolPref("font.bold", this.MMS_EF_B);
  prefBranch.setBoolPref("font.italic", this.MMS_EF_I);
  prefBranch.setBoolPref("font.underline", this.MMS_EF_U);
  prefBranch.setBoolPref("font.strike", this.MMS_EF_S);
  prefBranch.setCharPref("font.color", this.MMS_CO);
}

function createMessageContentNode(text, mms) {
  var doc = window.document;
  var openEyesEmoticons = "@)(DS|PO";
  var msg = doc.createElementNS(XHTML, "div");
  msg.setAttribute("class", "message");
  if (typeof(mms) == "string") {
    var style = convertXMMStoStyle(mms);
    msg.setAttribute("style", style);
  }
  var start = 0;
  for (var i = 0; i < text.length; i++) {
    var letter = text.charAt(i);
    switch (letter) {
      case ":":
        var letter2 = text.charAt(i + 1).toUpperCase();
        if (openEyesEmoticons.indexOf(letter2) >= 0 && letter2 != "") {
          addText(text.substr(start, i - start));
          addEmoticon(":" + letter2);
          start = i + 2;
        }
        break;
      case ";":
        if (text.charAt(i + 1) == ")") {
          addText(text.substr(start, i - start));
          addEmoticon(";)");
          start = i + 2;
        }
      case "h":
        i++;
        if (text.substr(i, 6) == "ttp://") {
          var httpEndPos = text.indexOf("\n", i);
          addText(text.substr(start, i - start - 1));
          if (httpEndPos == -1) {
            httpEndPos = text.indexOf(" ", i);
            if (httpEndPos == -1) {
              var link = "h" + text.substr(i, text.length - i);
              addLink(link);
              i = text.length;
              start = text.length;
            }
            else {
              var link = "h" + text.substr(i, httpEndPos - i);
              addLink(link);
              i = httpEndPos;
              start = httpEndPos;
            }
          }
          else {
            var link = "h" + text.substr(i, httpEndPos - i);
            addLink(link);
            i = httpEndPos;
            start = httpEndPos;
          }
        }
        break;
    }
  }
  if (start != i) {
    addText(text.substr(start, i - start));
  }
    
  function addText(t) {
    var textNode = doc.createTextNode(t);
    msg.appendChild(textNode);
  }
  function addEmoticon(e) {
    var imageNode = document.createElementNS(XHTML, "img");
    imageNode.setAttribute("src", Emoticons[e]);
    imageNode.setAttribute("alt", e);
    imageNode.setAttribute("width", 19);
    imageNode.setAttribute("height", 19);
    msg.appendChild(imageNode);
  }
  function addLink(l) {
    var linkNode = doc.createElementNS(XHTML, "a");
    var textNode = doc.createTextNode(l);
    linkNode.setAttribute("href", l);
    linkNode.appendChild(textNode);
    msg.appendChild(linkNode);
    linkNode.addEventListener("click", catchLink, true);
  }

  return msg;
}

function createMessageNode(from, textObj, myMsg) {
  var doc = window.document;
  from += ":";
  var msg = doc.createElementNS(XHTML, "div");
  msg.setAttribute("class", "InstantMessage");
  var nFrom = doc.createElementNS(XHTML, "div");
  var fNode = doc.createTextNode(from);
  nFrom.appendChild(fNode);
  if (myMsg == true) {
    nFrom.setAttribute("class", "From FromMe");        
  }
  else {
    nFrom.setAttribute("class", "From");
  }
  msg.appendChild(nFrom);
  if (typeof(textObj) == "string")
    textObj = this.createMessageContentNode(textObj);
  msg.appendChild(textObj);
  this.appendAndScroll(msg);
}

function appendAndScroll(node) {
  var panel = document.getElementById("chat-panel").contentDocument;
  panel.body.appendChild(node);
  try {
    panel.defaultView.scrollTo(0, panel.body.offsetHeight);
  } catch (ex) {
    alert(ex);
  }
}

function convertXMMStoStyle(mms) {
  var params = new Array();
  var fields = mms.split("; ");
  var font = '';
  var fontFamily = '';
  var style = '';
  for (field in fields) {
    var param = fields[field].split("=");
    params[param[0].toUpperCase()] = param[1];
  }
  if (typeof(params["FN"]) != "undefined") {
    font = "\'" + unescape(params["FN"]) + "\'";
  }
  if (typeof(params["EF"]) != "undefined") {
    for (var i = 0; i < params["EF"].length; i++) {
      switch (params["EF"].substr(i, 1)) {
        case "B":
          style += "font-weight: bold; ";
          break;
        case "I":
          style += "font-style: italic; ";
          break;
        case "U":
          style += "text-decoration: underline; ";
          break;
        case "S":
          style += "text-decoration: line-through; ";
          break;
      }
    }
  }
  if (typeof(params["CO"]) != "undefined") {
    var bgr = "000000".substr(0, 6 - params["CO"].length) + params["CO"];
    style += "color: #" + swapRedBlue(bgr) + "; ";
  }
  if (typeof(params["PF"]) != "undefined") {
    switch (params["PF"].substr(0, 1)) {
      case "1":
        fontFamily = "serif";
        break;
      case "2":
        fontFamily = "sans-serif";
        break;
      case "3":
        fontFamily = "monospace";
        break;
      case "4":
        fontFamily = "cursive";
        break;
      case "5":
        fontFamily = "fantasy";
        break;
    }
  }
  if (typeof(params["RL"]) != "undefined" && params["RL"] == "1") {
    style += "text-align: right; ";
  }
  if (font != '' && fontFamily != '') {
    style += "font-family: " + font + ", " + fontFamily + "; ";
  }
  else {
    if (!(font == '' && fontFamily == '')) {
      style += "font-family: " + font + fontFamily + "; ";
    }
  }
  dump(style + '\r\n');
  return style;
}

function swapRedBlue(color) {
  return color.substr(4, 2) + color.substr(2, 2) + color.substr(0, 2)
}

function getTimeStamp() {
  var d = new Date();
  var hours = ensureTwoDigits(d.getHours());
  var minutes = ensureTwoDigits(d.getMinutes());
  var timeStamp = d.getFullYear() + "/" + (d.getMonth() + 1) + "/" + d.getDate() + " ";
  timeStamp += hours + ":" + minutes;

  function ensureTwoDigits(number) {
    var ensuredNumber = "";
    if (number > 9) {
      ensuredNumber = number;
    }
    else {
      ensuredNumber = "0" + number;
    }
    return ensuredNumber;
  }

  return timeStamp;
}

function logIM(contactID, msgText) {
  line = uniConvertFrom("[" + getTimeStamp() + "] <" + contactID + "> " + msgText + '\r\n');
  window.fileStream.write(line, line.length);
}